import java.util.*;

public class Arraz {

    public int sumValuesOfArray(int[] arr){
        int sum = 0;
        for(int i:arr){
            sum += i;
        }
        return sum;
    }

    public double sumDoublesOfArray(double[] arr){
        double sum = 0;
        for(double d:arr){
            sum += d;
        }
        return sum;
    }

    public int averageOfArray(int[] arr){

        int sum = sumValuesOfArray(arr);
        return (int)Math.floor(sum/arr.length);
    }

    public double doubleAverageOfArray(double[] arr){
        double sum = sumDoublesOfArray(arr);
        return sum/arr.length;
    }

    public boolean containsValue(int[] arr, int value){
        for(int i:arr){
            if(i==value){
                return true;
            }
        }
        return false;
    }

    public int[] reverseArray(int[] arr){
        int[] result = new int[arr.length];
        int start = 0;
        int end = arr.length-1;

        while (start<end){
            result[start] = arr[end];
            result[end] = arr[start];
            start++;
            end--;
        }
        return result;
    }

    public OddEven getOddEvensOfArray(int[] array){
        OddEven oddEven = new OddEven();
        int even = 0;
        int odd = 0;
        for (int i = 0; i < array.length; i++) {
            if(array[i]%2==0){
                even++;
            }else{
                odd++;
            }
        }
        oddEven.setEvens(even);
        oddEven.setOdds(odd);
        return oddEven;
    }

    public int findIndexOf(int[] array, int value){

        for (int i = 0; i < array.length; i++) {
            if(array[i]==value){
                return i;
            }
        }
        return -1;
    }

    public Integer[] copyArrayByInterator(Integer[] array) {
        Integer[] newArray = new Integer[array.length];
        int i = 0;
        Iterator<Integer> intIterator = Arrays.asList(array).iterator();
        while(intIterator.hasNext()){
            newArray[i] = intIterator.next();
            i++;
        }
        return newArray;
    }

    public int[] copyArrayByLoop(int[] array) {
        int[] copy = new int[array.length];
        int index=0;
        for (int i = 0; i < array.length; i++) {
            copy[index] = array[i];
            index++;
        }
        return copy;
    }

    public int[] removeElementFromArray(int[] array, int value){
        int[] newArray = new int[array.length-1];
        int index = 0;
        for (int i = 0; i < array.length; i++) {
            if(array[i]!=value) {
                newArray[index] = array[i];
            }else {
                continue;
            }
            index++;
        }
        return newArray;
    }


    public int[] insertIntoArrayAt(int[] array, int value, int index) {
        int[] newArray = new int[array.length+1];

        for (int i = 0; i < newArray.length; i++) {
            if(i==index){
                newArray[i]=value;
            }
            else if(i<index){
                newArray[i] = array[i];
            }else if(i>index){
                newArray[i] = array[i-1];
            }
        }
        return newArray;
    }

    public MaxMin findMaxMinOfArray(int[] array){
        MaxMin maxMin = new MaxMin();
        int max=array[0];
        int min=array[0];

        for (int i = 0; i < array.length; i++) {
            if(array[i]>max){
                max = array[i];
            }else if(array[i]<min){
                min = array[i];
            }
        }
        maxMin.setMax(max);
        maxMin.setMin(min);

        return maxMin;
    }

    public Integer[] removeDupesFromArray(Integer[] array) {
        HashSet<Integer> set = new HashSet<>();
        ArrayList<Integer> list = new ArrayList<>();
        for (int i = 0; i < array.length; i++) {
            if(set.add(array[i])){
                list.add(array[i]);
            }
        }
        return makeMeAnArrayFromArrayList(list);
    }

    public Double find2ndLargestValueFromArray(Double[] array) {
        Arrays.sort(array);

        return array[array.length-2];
    }


    public List<Integer> makeMeAnArrayListFromArray(Integer[] array) {
        List<Integer> intList = Arrays.asList(array);
        return intList;
    }

    public Integer[] makeMeAnArrayFromArrayList(ArrayList<Integer> intList){
        Integer[] intArray = new Integer[intList.size()];
        return intList.toArray(intArray);
    }

    public boolean check2ArraysForEqual(int[] array1, int[] array2) {
        boolean same = false;
        for (int i = 0; i <array1.length ; i++) {
            if(array1[i] == array2[i]){
                same = true;
                array2[i]++;
            }else{
                same = false;
            }
        }
        return same;
    }

    public double averageArrayWithoutMaxMin(int[] array) {
        Arrays.sort(array);
        int sum =0;
        for (int i = 1; i < array.length-1; i++) {
            sum+=array[i];
        }
        return sum/(array.length-2);
    }


    public boolean arrayHas65and77(int[] array) {
        boolean has65 = false;
        boolean has77 = false;
        for (int i = 0; i < array.length; i++) {
            if(array[i]==65){
                has65 = true;
            }else if (array[i]==77){
                has77 = true;
            }
        }
        return(has65 && has77);
    }


    public boolean theTotalofTensIs30(int[] array) {
        int sum=0;
        boolean is30 = false;
        for (int i = 0; i < array.length; i++) {
            if(array[i]==10){
                sum+=10;
            }
        }
        if(sum==30) {
            is30 =  true;
        }else{
            is30 =  false;
        }
        return is30;
    }

    public SmallestAndNext findSmallestN2ndSmallest(int[] array) {
        SmallestAndNext smallestAndNext = new SmallestAndNext();
        Arrays.sort(array);
        smallestAndNext.setSmallest(array[0]);
        smallestAndNext.setSecondSmallest(array[1]);

        return smallestAndNext;
    }

    public int[] makeMeACopyPlease(int[] array){
        int[] newArray = Arrays.copyOf(array,array.length);
        int start = 0;
        int end = array.length-1;

        while (start<end){
            int temp = array[start];
            newArray[start] = array[end];
            newArray[end] = temp;
            start++;
            end--;
        }
        return newArray;
    }


    public int[] removeLastItemAndCopy(int[] array) {
        return Arrays.copyOfRange(array,0,array.length-1);
    }

    public int[] removeFirstItemAndCopy(int[] array){
        return Arrays.copyOfRange(array,1,array.length);
    }

    public int[] insertAtStartAndCopy(int[] array, int value) {
        int[] newArray = Arrays.copyOf(array,array.length+1);
        newArray[0] = value;
        for (int i = 1; i < newArray.length; i++) {
            newArray[i]=array[i-1];
        }
        return newArray;
    }

    public int[] insertAtEndAndCopy(int[] array, int value) {
        int[] newArray = new int[array.length+1];
        int index = 0;
        for (int i = 0; i <array.length ; i++) {
            newArray[index]=array[i];
            index++;
        }
        newArray[newArray.length-1] = value;
        return newArray;
    }

    public int[] sortArrayIntoEvensThenOdds(int[] array){
        int[] newArray = new int[array.length];
        int index = 0;
        for (int i = 0; i < array.length; i++) {
            if(array[i]%2==0){
                newArray[index] = array[i];
                index++;
            }
        }
        for (int i = 0; i < array.length; i++) {
            if(array[i]%2!=0){
                newArray[index] = array[i];
                index++;
            }
        }
        return newArray;
    }
}
