import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;

import static org.junit.Assert.*;

public class ArrazTest {
    Arraz arraz = new Arraz();

    @Test
    public void test1SumValuesOfArray(){
        int[] arr = {1,2,3,4,5,6};

        int expected = 21;
        int actual = arraz.sumValuesOfArray(arr);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test2SumValuesOfArray(){
        int[] arr = {20,25};

        int expected = 45;
        int actual = arraz.sumValuesOfArray(arr);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test1SumDoublesOfArray(){
        double[] arr = {1.0,2.0,3.0,4.5};

        double expected = 10.5;
        double actual = arraz.sumDoublesOfArray(arr);

        Assert.assertEquals(expected,actual, 0.01);
    }

    @Test
    public void test2SumDoublesOfArray(){
        double[] arr = {2.5,2.5,2.5,2.5};

        double expected = 10.0;
        double actual = arraz.sumDoublesOfArray(arr);

        Assert.assertEquals(expected,actual,0.01);
    }

    @Test
    public void test1AverageOfArray(){
        int[] arr = {2,2,2};

        int expected = 2;
        int actual = arraz.averageOfArray(arr);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test2AverageOfArray(){
        int[] arr = {2,3,4,5};

        int expected = 3;
        int actual = arraz.averageOfArray(arr);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test1doubleAverageOfArray(){
        double[] arr = {1.0,2.0,3.0,4.0};

        double expected = 2.5;
        double actual = arraz.doubleAverageOfArray(arr);

        Assert.assertEquals(expected,actual, 0.001);
    }

    @Test
    public void test2doubleAverageOfArray(){
        double[] arr = {2.5,2.5,2.5,2.5};

        double expected = 2.5;
        double actual = arraz.doubleAverageOfArray(arr);

        Assert.assertEquals(expected,actual,0.01);
    }

    @Test
    public void testContainsValue_whenTrue(){
        int[] arr = {1,2,3,4,5};
        int value = 2;

        boolean expected = true;
        boolean actual = arraz.containsValue(arr,value);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void testContainsValue_whenFalse(){
        int[] arr = {1,2,3,4,5,6};

        boolean expected = false;
        boolean actual = arraz.containsValue(arr,10);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test1ReverseArray(){
        int[] arr = {1,2,3,4,5};

        int expected = 5;
        int actual = arraz.reverseArray(arr)[0];

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test2ReverseArray(){
        int[] arr = {4,6,7,8,3};

        int expected = 8;
        int actual = arraz.reverseArray(arr)[1];

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test1getOddEvensOfArray(){
        int[] array = {1,2,3,4,5,6,7};

        int oddExpected = 4;
        int oddActual = arraz.getOddEvensOfArray(array).getOdds();
        int evenExpected = 3;
        int evenActual = arraz.getOddEvensOfArray(array).getEvens();

        Assert.assertEquals(oddExpected,oddActual);
        Assert.assertEquals(evenExpected,evenActual);
    }

    @Test
    public void test2getOddEvensOfArray(){
        int[] array = {2,4,6,8};

        int oddExpected = 0;
        int oddActual = arraz.getOddEvensOfArray(array).getOdds();
        int evenExpected = 4;
        int evenActual = arraz.getOddEvensOfArray(array).getEvens();

        Assert.assertEquals(oddExpected,oddActual);
        Assert.assertEquals(evenExpected,evenActual);
    }

    @Test
    public void test1findIndexOf_whenExists(){
        int[] array = {1,2,3,4,5,6};

        int expected = 2;
        int actual = arraz.findIndexOf(array,3);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test1findIndexOf_whenDoesntExist(){
        int[] array = {1,2,3,4,5,6};

        int expected = -1;
        int actual = arraz.findIndexOf(array,9);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test1copyArrayByInterator(){
        Integer[] array = {2,4,6,8,10};

        Integer[] expected = {2,4,6,8,10};
        Integer[] actual = arraz.copyArrayByInterator(array);

        Assert.assertArrayEquals(expected,actual);
    }

    @Test
    public void test2copyArrayByInterator(){
        Integer[] array = {1,2,3,4,5,6};

        Integer[] expected = {1,2,3,4,5,6};
        Integer[] actual = arraz.copyArrayByInterator(array);

        Assert.assertArrayEquals(expected,actual);
    }

    @Test
    public void test1copyArrayByLoop(){
        int[] array = {2,4,6,8,10};

        int[] expected = {2,4,6,8,10};
        int[] actual = arraz.copyArrayByLoop(array);

        Assert.assertArrayEquals(expected,actual);
    }

    @Test
    public void test2copyArrayByLoop(){
        int[] array = {1,2,3,4,5,6};

        int[] expected = {1,2,3,4,5,6};
        int[] actual = arraz.copyArrayByLoop(array);

        Assert.assertArrayEquals(expected,actual);
    }

    @Test
    public void test1removeElementFromArray(){
        int[] array = {1,2,3,4,5,6};
        int value = 3;

        int[] expected = {1,2,4,5,6};
        int[] actual = arraz.removeElementFromArray(array,value);


        Assert.assertArrayEquals(expected,actual);
    }

    @Test
    public void test2removeElementFromArray(){
        int[] array = {2,4,6,8,10};

        int[] expected = {4,6,8,10};
        int[] actual = arraz.removeElementFromArray(array,2);

        Assert.assertArrayEquals(expected,actual);
    }

    @Test
    public void test1insertIntoArrayAt(){
        int[] array = {1,2,3,4,5,6};

        int expected = 4;
        int actual = arraz.insertIntoArrayAt(array,4,1)[1];

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test2InsertIntoArrayAt(){
        int[] array = {2,4,6,8,10};

        int[] expected = {2,4,6,1,8,10};
        int[] actual = arraz.insertIntoArrayAt(array,1,3);

        Assert.assertArrayEquals(expected,actual);
    }

    @Test
    public void test1findMaxMinOfArray(){
        int[] array = {1,2,3,4,5};

        int maxExpected = 5;
        int maxActual = arraz.findMaxMinOfArray(array).getMax();
        int minExpected = 1;
        int minActual = arraz.findMaxMinOfArray(array).getMin();

        Assert.assertEquals(maxExpected,maxActual);
        Assert.assertEquals(minExpected,minActual);
    }

    @Test
    public void test2findMaxMinOfArray(){
        int[] array = {2,4,6,8,10};

        int maxExpected = 10;
        int maxActual = arraz.findMaxMinOfArray(array).getMax();
        int minExpected = 2;
        int minActual = arraz.findMaxMinOfArray(array).getMin();

        Assert.assertEquals(maxExpected,maxActual);
        Assert.assertEquals(minExpected,minActual);
    }

    @Test
    public void test1removeDupesFromArray(){
        Integer[] array = {1,2,3,4,5,3};

        Integer[] expected = {1,2,3,4,5};
        Integer[] actual = arraz.removeDupesFromArray(array);

        Assert.assertArrayEquals(expected,actual);
    }

    @Test
    public void test2removeDupesFromArray(){
        Integer[] array = {1,1,1,1};

        Integer[] expected = {1};
        Integer[] actual = arraz.removeDupesFromArray(array);

        Assert.assertArrayEquals(expected,actual);
    }

    @Test
    public void test1find2ndLargestValueFromArray(){
        Double[] array = {1.0,2.0,3.0,5.0,4.0};

        Double expected = 4.0;
        Double actual = arraz.find2ndLargestValueFromArray(array);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test2find2ndLargestValueFromArray(){
        Double[] array = {5.0,2.0,3.0,4.0,1.0};

        Double expected = 4.0;
        Double actual = arraz.find2ndLargestValueFromArray(array);

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test1makeMeAnArrayListFromArray(){
        Integer[] array = {1,2,3,4,5};

        int expected = 5;
        int actual = arraz.makeMeAnArrayListFromArray(array).size();

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test2makeMeAnArrayListFromArray(){
        Integer[] array = {1,2,3,4,5,7,8,9};

        int expected = 8;
        int actual = arraz.makeMeAnArrayListFromArray(array).size();

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test1makeMeAnArrayFromArrayList(){
        ArrayList<Integer> intList = new ArrayList<Integer>();
        intList.add(1);
        intList.add(2);
        intList.add(3);
        intList.add(4);

        int expected = 4;
        int actual = arraz.makeMeAnArrayFromArrayList(intList).length;

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test2makeMeAnArrayFromArrayList() {
        ArrayList<Integer> intList = new ArrayList<Integer>();
        intList.add(1);
        intList.add(2);
        intList.add(4);

        int expected = 3;
        int actual = arraz.makeMeAnArrayFromArrayList(intList).length;

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void test1check2ArraysForEqual(){
        int[] array1 = {1,2,3,4,5};
        int[] array2 = {1,2,3,4,5};

        Assert.assertTrue(arraz.check2ArraysForEqual(array1,array2));
    }

    @Test
    public void test2check2ArraysForEqual(){
        int[] array1 = {1,2,3,4,5};
        int[] array2 = {5,4,3,2,1};

        Assert.assertFalse(arraz.check2ArraysForEqual(array1, array2));
    }

    @Test
    public void test1averageArrayWithoutMaxMin(){
        int[] array = {1,2,3,4,5};

        double expected = 3.0;
        double actual = arraz.averageArrayWithoutMaxMin(array);

        Assert.assertEquals(expected,actual,0.001);
    }

    @Test
    public void test2averageArrayWithoutMaxMin(){
        int[] array = {2,3,2,2,5};

        double exptected = 2.0;
        double actual = arraz.averageArrayWithoutMaxMin(array);

        Assert.assertEquals(exptected,actual,0.001);
    }

    @Test
    public void testarrayHas65and77_whenTrue(){
        int[] array = {1,2,65,3,4,77};

        Assert.assertTrue(arraz.arrayHas65and77(array));
    }

    @Test
    public void testarrayHas65and77_whenFalse(){
        int[] array = {1,2,4,3,4,5};

        Assert.assertFalse(arraz.arrayHas65and77(array));
    }

    @Test
    public void testarrayHas65and77_whenTheresOne(){
        int[] array = {1,2,65,3,4,5};

        Assert.assertFalse(arraz.arrayHas65and77(array));
    }

    @Test
    public void testtheTotalofTensIs30_whenTrue(){
        int[] array = {10,10,11,12,10};

        Assert.assertTrue(arraz.theTotalofTensIs30(array));
    }

    @Test
    public void testtheTotalofTensIs30_whenFalse(){
        int[] array = {1,3,11,10,2};

        Assert.assertFalse(arraz.theTotalofTensIs30(array));
    }

    @Test
    public void test1FindSmallestAnd2ndSmallest(){
        int[] array = {13,4,5,2,22,67,12};

        int expectedSm = 2;
        int actualSm = arraz.findSmallestN2ndSmallest(array).getSmallest();
        int expectedNext = 4;
        int actualNext = arraz.findSmallestN2ndSmallest(array).getSecondSmallest();

        Assert.assertEquals(expectedNext,actualNext);
        Assert.assertEquals(expectedSm,actualSm);
    }

    @Test
    public void test2FindSmallestAnd2ndSmallest(){
        int[] array = {43,2,6,2,7,8,34,21};

        int expectedSm = 2;
        int actualSm = arraz.findSmallestN2ndSmallest(array).getSmallest();
        int expectedNext = 2;
        int actualNext = arraz.findSmallestN2ndSmallest(array).getSecondSmallest();

        Assert.assertEquals(expectedNext,actualNext);
        Assert.assertEquals(expectedSm,actualSm);
    }

    @Test
    public void test1makeMeACopyPlease(){
        int[] array = {1,2,3,4,5};

        int[] expected = {5,4,3,2,1};
        int[] actual = arraz.makeMeACopyPlease(array);

        Assert.assertArrayEquals(expected,actual);
    }

    @Test
    public void test2makeMeACopyPlease(){
        int[] array = {6,5,4,3,2,1};

        int[] expected = {1,2,3,4,5,6};
        int[] actual = arraz.makeMeACopyPlease(array);

        Assert.assertArrayEquals(expected,actual);
    }

    @Test
    public void test1removeLastItemAndCopy(){
        int[] array = {1,2,3,4,5};

        Assert.assertTrue(arraz.removeLastItemAndCopy(array).length==4);
    }

    @Test
    public void test2removeLastItemAndCopy(){
        int[] array = {2,4,6,8,10,1,3,5,7};

        int expected = 8;
        int actual = arraz.removeLastItemAndCopy(array).length;

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test1removeFirstItemAndCopy(){
        int[] array = {1,2,3,4,5};

        Assert.assertTrue(arraz.removeFirstItemAndCopy(array).length==4);
    }

    @Test
    public void test2removeFirstItemAndCopy(){
        int[] array = {2,3,4,5,6,7};

        int[] expected = {3,4,5,6,7};
        int[] actual = arraz.removeFirstItemAndCopy(array);

        Assert.assertArrayEquals(expected,actual);
    }

    @Test
    public void test1insertAtStartAndCopy(){
        int[] array = {1,2,3,4,5};
        int value = 0;

        int expected = 6;
        int actual = arraz.insertAtStartAndCopy(array,value).length;

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test2insertAtStartAndCopy(){
        int[] array = {2,4,6,8};

        int[] expected = {1,2,4,6,8};
        int[] actual = arraz.insertAtStartAndCopy(array,1);

        Assert.assertArrayEquals(expected,actual);
    }

    @Test
    public void test1insertAtEndAndCopy(){
        int[] spiffyHandyIntArray = new int[] {4,5,102,6,-7,12,-32,92,8};
        int value = 10;

        int expected = 10;
        int actual = arraz.insertAtEndAndCopy(spiffyHandyIntArray,value).length;

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void test2insertAtEndAndCopy(){
        int[] array = {1,2,3,4,5};

        int[] expected = {1,2,3,4,5,6};
        int[] actual = arraz.insertAtEndAndCopy(array,6);

        Assert.assertArrayEquals(expected,actual);
    }

    @Test
    public void test1sortArrayIntoEvensThenOdds(){
        int[] array = {1,2,3,4};

        int[] expected = {2,4,1,3};
        int[] actual = arraz.sortArrayIntoEvensThenOdds(array);

        Assert.assertArrayEquals(expected,actual);
    }

    @Test
    public void test2sortArrayIntoEvensThenOdds(){
        int[] array = {1,2};

        int[] expected = {2,1};
        int[] actual = arraz.sortArrayIntoEvensThenOdds(array);

        Assert.assertArrayEquals(expected,actual);
    }
}